//
//  ViewController.m
//  TableViewIndex
//
//  Created by lujh on 2017/9/5.
//  Copyright © 2017年 lujh. All rights reserved.
//

#import "ViewController.h"
#import "SectionIndexItem.h"
#import "SectionIndexView.h"

@interface ViewController ()<DSectionIndexViewDelegate,DSectionIndexViewDataSource,UITableViewDelegate,UITableViewDataSource,UIScrollViewDelegate>

@property (strong, nonatomic) SectionIndexView *sectionIndexView;
@property (strong, nonatomic) NSMutableArray *sections;
@property (strong, nonatomic) NSMutableDictionary *sectionDic;
@property (nonatomic, strong) UITableView *tableview;
// 滚动的偏移量
@property (nonatomic,assign) CGFloat oldY;
// 当前显示的组头
@property (nonatomic,assign) NSUInteger currentSection;
// 是否是上拉滚动
@property (nonatomic,assign) BOOL isUpScroll;
// 是否第一次加载tableView
@property (nonatomic,assign) BOOL isFirstLoad;
@end

@implementation ViewController


#pragma mark - defalt

- (void)viewDidLoad {
    [super viewDidLoad];
    
    [self _createData];
    
    [self _initTableView];
    
    [self _initIndexView];
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    [self.sectionIndexView reloadItemViews];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}


#define kSectionIndexWidth 40.f
#define kSectionItemHeight 20.f
- (void)viewWillLayoutSubviews
{
    [super viewWillLayoutSubviews];
    
    CGFloat H = kSectionItemHeight*self.sections.count;
    _sectionIndexView.frame = CGRectMake(CGRectGetWidth(self.tableview.frame) - kSectionIndexWidth -10, (CGRectGetHeight(self.tableview.frame) - H)/2, kSectionIndexWidth, H);
    _sectionIndexView.layer.cornerRadius = 12;
    [_sectionIndexView setBackgroundViewFrame];
}

#pragma mark - private

- (void)_initIndexView
{
    _sectionIndexView = [[SectionIndexView alloc] init];
    _sectionIndexView.backgroundColor = [UIColor greenColor];
    _sectionIndexView.dataSource = self;
    _sectionIndexView.delegate = self;
    _sectionIndexView.isShowCallout = YES;
    _sectionIndexView.calloutViewType = CalloutViewTypeForUserDefined;
    _sectionIndexView.calloutDirection = SectionIndexCalloutDirectionLeft;
    _sectionIndexView.calloutMargin = 100.f;
    [self.view addSubview:self.sectionIndexView];
}

- (void)_initTableView
{
    _tableview = [[UITableView alloc] initWithFrame:self.view.bounds style:UITableViewStylePlain];
    _tableview.dataSource = self;
    _tableview.delegate = self;
    _tableview.showsVerticalScrollIndicator = NO;
    [self.view addSubview:_tableview];
    
    _isFirstLoad = YES;
}

- (void)_createData
{
    self.sectionDic = [NSMutableDictionary dictionary];
    NSArray *array1 = [NSArray arrayWithObjects:@"apparel",@"apparentness",@"appel",@"appeasement",@"appearance",@"appear",@"appellant",@"apostate",@"appellation",@"aposteriori",@"apospory ", nil];
    NSArray *array2 = [NSArray arrayWithObjects:@"byron",@"SB",nil];
    NSArray *array3 = [NSArray arrayWithObjects:@"cabbage",@"cable",@"cafe", nil];
    NSArray *array4 = [NSArray arrayWithObjects:@"dean",nil];
    NSArray *array5 = [NSArray arrayWithObjects:@"finsh",@"five",@"fine",@"fix", nil];
    NSArray *array6 = [NSArray arrayWithObjects:@"english",@"egg", nil];
    NSArray *array7 = [NSArray arrayWithObjects:@"great",@"gate",@"gif",@"github", nil];
    NSArray *array8 = [NSArray arrayWithObjects:@"hello",@"hungry",@"home",@"house",@"however",@"humble", nil];
    NSArray *array9 = [NSArray arrayWithObjects:@"idea",@"implemention",@"insistt",@"invite", nil];
    NSArray *array10 = [NSArray arrayWithObjects:@"Jack",@"job",@"just", nil];
    NSArray *array11 = [NSArray arrayWithObjects:@"kill",@"king", nil];
    NSArray *array12 = [NSArray arrayWithObjects:@"lucky",@"limit", nil];
    NSArray *array13 = [NSArray arrayWithObjects:@"money",@"much",@"many",@"man",@"million",@"meter",@"may",@"miracle",@"manage",nil];
    NSArray *array14 = [NSArray arrayWithObjects:@"nice",@"nick",@"navigate", nil];
    NSArray *array15 = [NSArray arrayWithObjects:@"ok",@"over",nil];
    NSArray *array16 = [NSArray arrayWithObjects:@"pik",@"pice",@"pizze",nil];
    NSArray *array17 = [NSArray arrayWithObjects:@"quite", nil];
    NSArray *array18 = [NSArray arrayWithObjects:@"request",@"rice",nil];
    NSArray *array19 = [NSArray arrayWithObjects:@"sister",@"sex",@"slider", nil];
    NSArray *array20 = [NSArray arrayWithObjects:@"tool",@"tumb",@"taxi",@"take", nil];
    NSArray *array21 = [NSArray arrayWithObjects:@"unity",@"unless",nil];
    NSArray *array22 = [NSArray arrayWithObjects:@"video",@"vs", nil];
    NSArray *array23 = [NSArray arrayWithObjects:@"world",@"work", nil];
    NSArray *array24 = [NSArray arrayWithObjects:@"XXOO", nil];
    NSArray *array25 = [NSArray arrayWithObjects:@"yellow",@"yet",@"yes",@"yard", nil];
    NSArray *array26 = [NSArray arrayWithObjects:@"zero",@"zike",@"zoom", nil];
    NSArray *array27 = [NSArray arrayWithObjects:@"13579",@"&&&&",@"38",@"250",@"349321810@qq.com",@"码农", nil];
    
    [self.sectionDic setObject:array1 forKey:@"A"];
    [self.sectionDic setObject:array2 forKey:@"B"];
    [self.sectionDic setObject:array3 forKey:@"C"];
    [self.sectionDic setObject:array4 forKey:@"D"];
    [self.sectionDic setObject:array5 forKey:@"E"];
    [self.sectionDic setObject:array6 forKey:@"F"];
    [self.sectionDic setObject:array7 forKey:@"G"];
    [self.sectionDic setObject:array8 forKey:@"H"];
    [self.sectionDic setObject:array9 forKey:@"I"];
    [self.sectionDic setObject:array10 forKey:@"J"];
    [self.sectionDic setObject:array11 forKey:@"K"];
    [self.sectionDic setObject:array12 forKey:@"L"];
    [self.sectionDic setObject:array13 forKey:@"M"];
    
    self.sections = [NSMutableArray arrayWithObjects:@"A",@"B",@"C",@"D",@"E",@"F",@"G",@"H",@"I",@"J",@"K",@"L",@"M"/*,@"N",@"O",@"P",@"Q",@"R",@"S",@"T",@"U",@"V",@"W",@"X",@"Y",@"Z",@"#"*/,nil];
    
}




#pragma mark UITableViewDataSource && delegate method
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return self.sections.count;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return [[self.sectionDic objectForKey:[self.sections objectAtIndex:section]] count];
}


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *identifier = @"IdentifierCell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:identifier];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:identifier];
        
    }
    
    cell.textLabel.text = [[self.sectionDic objectForKey:[self.sections objectAtIndex:indexPath.section]] objectAtIndex:indexPath.row];
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
}

- (CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section
{
    
    return 30;
}

- (UIView*)tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section
{
    
    UIView *view = [[UIView alloc] initWithFrame:CGRectMake(0, 0, self.view.frame.size.width, 30)];
    view.backgroundColor = [UIColor cyanColor];
    
    UILabel *label = [[UILabel alloc] initWithFrame:view.bounds];
    label.text = [self.sections objectAtIndex:section];
    label.textAlignment = NSTextAlignmentCenter;
    label.textColor = [UIColor redColor];
    [view addSubview:label];
    return view;
}

#pragma mark DSectionIndexViewDataSource && delegate method
- (NSInteger)numberOfItemViewForSectionIndexView:(SectionIndexView *)sectionIndexView
{
    return self.tableview.numberOfSections;
}

- (SectionIndexItem *)sectionIndexView:(SectionIndexView *)sectionIndexView itemViewForSection:(NSInteger)section
{
    SectionIndexItem *itemView = [[SectionIndexItem alloc] init];
    itemView.titleLabel.text = [self.sections objectAtIndex:section];
    itemView.titleLabel.font = [UIFont systemFontOfSize:12];
    itemView.titleLabel.textColor = [UIColor darkGrayColor];
    itemView.titleLabel.highlightedTextColor = [UIColor redColor];
    itemView.titleLabel.shadowColor = [UIColor whiteColor];
    itemView.titleLabel.shadowOffset = CGSizeMake(0, 1);
    [itemView setSelected:YES animated:YES];
    itemView.titleLabel.tag = section +1;
    return itemView;
}

- (UIView *)sectionIndexView:(SectionIndexView *)sectionIndexView calloutViewForSection:(NSInteger)section
{
    UILabel *label = [[UILabel alloc] init];
    label.frame = CGRectMake(0, 0, 80, 80);
    label.center = self.view.center;
    label.text = [self.sections objectAtIndex:section];
    label.backgroundColor = [UIColor clearColor];
    label.textColor = [UIColor redColor];
    label.font = [UIFont boldSystemFontOfSize:36];
    label.textAlignment = NSTextAlignmentCenter;
    [label.layer setCornerRadius:label.frame.size.width/2];
    [label.layer setBorderColor:[UIColor lightGrayColor].CGColor];
    [label.layer setBorderWidth:3.0f];
    [label.layer setShadowColor:[UIColor blackColor].CGColor];
    [label.layer setShadowOpacity:0.8];
    [label.layer setShadowRadius:5.0];
    [label.layer setShadowOffset:CGSizeMake(2.0, 2.0)];
    return label;
}

- (NSString *)sectionIndexView:(SectionIndexView *)sectionIndexView
               titleForSection:(NSInteger)section
{
    return [self.sections objectAtIndex:section];
}

- (void)sectionIndexView:(SectionIndexView *)sectionIndexView didSelectSection:(NSInteger)section
{
    
    
    UILabel *label = [self.view viewWithTag:section+1];
    
    
    for (int i = 1; i<=self.sections.count; i++) {
        
        UILabel *otherLabel = [self.view viewWithTag:i];
        
        if (section != i -1) {
            
            otherLabel.font = [UIFont systemFontOfSize:12];
        }
        
        if (section == i-1) {
            
            label.font = [UIFont systemFontOfSize:20];
        }
    }
    
    
    [self.tableview scrollToRowAtIndexPath:[NSIndexPath indexPathForRow:0 inSection:section] atScrollPosition:UITableViewScrollPositionTop animated:YES];
}




- (void)tableView:(UITableView *)tableView willDisplayHeaderView:(UIView *)view forSection:(NSInteger)section{
    
    
    // 向下
    if(!_isUpScroll && (_currentSection - section) == 1){
        
        //最上面组头（不一定是第一个组头，指最近刚被顶出去的组头）又被拉回来
        
        _currentSection = section;
        
        NSLog(@"willDisplayHeaderView显示第%ld组",(long)section);
        
        NSLog(@"willDisplayHeaderView -----%@",self.sections[section]);
        
        UILabel *label = [self.view viewWithTag:section+1];
        
        
        for (int i = 1; i<=self.sections.count; i++) {
            
            UILabel *otherLabel = [self.view viewWithTag:i];
            
            if (section != i -1) {
                
                otherLabel.font = [UIFont systemFontOfSize:12];
            }
            
            if (section == i-1) {
                
                label.font = [UIFont systemFontOfSize:20];
            }
        }
        
    }
    
}


- (void)tableView:(UITableView *)tableView didEndDisplayingHeaderView:(UIView *)view forSection:(NSInteger)section{
    
    // 向上
    if(!_isFirstLoad && _isUpScroll){
        
        _currentSection = section + 1;
        
        UILabel *label = [self.view viewWithTag:section+2];
        
        UILabel *firstLabel = [self.view viewWithTag:section +1];
        firstLabel.font = [UIFont systemFontOfSize:12];
        
        for (int i = 2; i<=self.sections.count; i++) {
            
            UILabel *otherLabel = [self.view viewWithTag:i];
            
            if ((section +1)!= i -1) {
                
                otherLabel.font = [UIFont systemFontOfSize:12];
            }
            
            if ((section +1) == i-1) {
                
                label.font = [UIFont systemFontOfSize:20];
            }
        }
        
    }
    
}

int _lastPosition;

- (void)scrollViewDidScroll:(UIScrollView *)scrollView{
    
    int currentPostion = scrollView.contentOffset.y;
    
    if (currentPostion - _lastPosition > 0.01) {
        _lastPosition = currentPostion;
        _isUpScroll = YES;
        
    }
    else if (_lastPosition - currentPostion > 0.01)
    {
        _lastPosition = currentPostion;
        _isUpScroll = NO;
        
    }
    
    _isFirstLoad = NO;
    
}

@end
